#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>

// this header is basically self-documenting

struct game_info {
	int loadtime;             // preparation time for the bot
	int turntime;             // time for deciding the movements (a turn)
	int rows;                 // number of rows in the map
	int cols;                 // number of columns in the map
	int turns;                // maximum number of turns
	int viewradius_sq;        // ants' view radius
	int attackradius_sq;      // ants' attack radius
	int spawnradius_sq;       // ants' spawn radius
    int seed;                 // random seed
	char *map;                // map (array of strings)
};

// basic ant position and owner
struct basic_ant {
    int row;        // row where the ant is placed
    int col;        // column where the ant is placed
    char player;    // owner id
};

// my ant position and id
struct my_ant {
    int id;         // owner id
    int row;        // ant row
    int col;        // ant column
};

// food position
struct food {
    int row;        
    int col;
};

// hill position and owner
struct hill {
    int row;
    int col;
    char player;
};

// game status in an specific turn
struct game_state {
    struct my_ant *my_ants;         // array of ants
    struct basic_ant *enemy_ants;   // array of enemies
    struct food *food;              // array of food position
    struct basic_ant *dead_ants;    // array of dead ants
    struct hill *hill;              // array of hills
    
    int my_count;         // number of ants
    int enemy_count;      // number of enemies
    int food_count;       // number of food
    int dead_count;       // number of dead ants
    int hill_count;       // number of hills

    int my_ant_index;
};
